"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Label = exports.LabelContainer = void 0;
const react_1 = __importStar(require("react"));
const react_popper_1 = require("react-popper");
const classnames_1 = __importDefault(require("classnames"));
const component_id_1 = require("@teambit/component-id");
const use_animation_frame_1 = __importDefault(require("use-animation-frame"));
require("@popperjs/core");
const default_label_1 = require("./default-label");
const component_label_1 = require("./component-label");
const label_module_scss_1 = __importDefault(require("./label.module.scss"));
// TODO - replace this with TippyJS, when it supports a `targetElement={targetRef.current}` prop
function LabelContainer(_a) {
    var { targetRef, offset, placement, flip = true, className } = _a, rest = __rest(_a, ["targetRef", "offset", "placement", "flip", "className"]);
    const [sourceRef, setSourceRef] = react_1.useState(null);
    const modifiers = react_1.useMemo(() => [{ name: "offset", options: { offset } }], [flip, offset]);
    const { styles, attributes, update } = react_popper_1.usePopper(targetRef, sourceRef, {
        modifiers,
        placement
    });
    use_animation_frame_1.default(() => update === null || update === void 0 ? void 0 : update(), [update]);
    if (!targetRef)
        return null;
    return (react_1.default.createElement("div", Object.assign({}, rest, { ref: setSourceRef, className: classnames_1.default(label_module_scss_1.default.label, className), style: styles.popper }, attributes.popper)));
}
exports.LabelContainer = LabelContainer;
function Label(_a) {
    var { componentId, link, scopeLink, local } = _a, rest = __rest(_a, ["componentId", "link", "scopeLink", "local"]);
    const parsedId = react_1.useMemo(() => component_id_1.ComponentID.tryFromString(componentId), [componentId]);
    if (!parsedId)
        return react_1.default.createElement(default_label_1.DefaultLabel, { href: link }, componentId);
    return (react_1.default.createElement(component_label_1.ComponentLabel, Object.assign({}, rest, { local: local, componentId: parsedId, link: link, scopeLink: scopeLink })));
}
exports.Label = Label;
//# sourceMappingURL=label.js.map